// interface.c
/*
UC: 21178 - Laboratorio de Programacao
Ano 2019/20 - EFOLIO B - Mundo dos rectangulos - UAb
18/05/2020
- Marcio Santos n.º 1502471
*/
#include<stdio.h>
#include<math.h>
#include<stdlib.h>
#include<stdarg.h>
#include<string.h>
#include<termios.h>
#include<unistd.h>
#include<fcntl.h>
#include<signal.h>
#include<time.h>
#include<sys/ioctl.h>
#include<assert.h>
#include "interface.h"
#include "shell.h"

const char* txt_fortune[] = {
  "#1- You will find a bushel of money",
  "#2- Your smile will tell you what makes you feel good.",
  "#3- Don’t panic",
  "#4- The best year-round temperature is a warm heart and a cool head",
  "#5- It could be better, but it’s good enough.",
  "#6- You will find a thing. It may be important",
  "#7- Your reality check about to bounce.",
  "#8- Two days from now, tomorrow will be yesterday.",
  "#9- When chosen for jury duty, tell judge fortune cookie say 'guilty!'",
  "#10- Stop eating now. Food poisoning no fun.",
  "#11- You are cleverly disguised as responsible adult.",
  "#12- Drive like hell, you will get there.",
  "#13- Person who eat fortune cookie get lousy dessert.",
  "#14- Okay to look at past and future. Just don’t stare.",
  "#15- Soup was secret family recipe made from toad. Hope you liked!",
  "#16- You will soon have an out of money experience.",
  "#17- He who dies with most toys, still dies.",
  "#18- Person who rests on laurels gets thorn in backside.",
  "#19- Two can live as cheaply as one, for half as long.",
  "#20- Life is a sexually transmitted condition.",
  "#21- Give person fish, he eat for day. Teach person to fish, he always smell funny.",
  "#22- Person who argues with idiot is taken for fool.",
  "#23- Look before you leap. Or wear a parachute.",
  "#24- The end is near, might as well have dessert.",
  "#25- This fortune no good. Try another.",
  "#26- Wise husband is one who thinks twice before saying nothing.",
  "#27- Marriage lets you annoy one special person for the rest of your life",
  "#28- Run",
  "#29- Make love, not bugs",
  "#30- You will read this and say 'Geez! I could come up with better fortunes than that!'",
  "#31- I cannot help you, for I’m just a cookie",
  "#32- The fortune you seek, is in another cookie",
  "#33- Don’t eat any Chinese food today or you’ll be sick!",
  "#34- About time I got out of that cookie!",
  "#35-  Come back later….I’m sleeping (yes, cookies need their sleep too)",
  "#36-  You will be hungry again in one hour",
  "#37- You will die alone and poorly dressed",
  "#38- Warning: do not eat your fortune",
  "#39- If you can read this, you are literate. Congratulations",
  "#40- You can always find happiness at work on Friday.",
  "#41- Let’s just say that the cookie is going to be the better part of the “fortune cookie.",
  "#42- Do not mistake temptation for opportunity.",
  "#43- Man with hole in pocket feel cocky all day.",
  "#44- A woman who seeks to be equal with men lacks ambition.",
  "#45- The greatest danger could be your stupidity.",
  "#46- The only normal people are the ones you don't know very well.",
  "#47- Doesn't expecting the unexpected make the unexpected become the expected?",
  "#48- Forgive your enemies...but REMEMBER THEIR NAMES!",
  "#49- You may write in your own fortune on the line __________________________________________.",
  "#50- He who laughs at himself never runs out of things to laugh at.",
  "#51- He who laughs last is laughing at you.",
  "#52- The Chinese food you just finished was the most American made thing you have bought since 1995.",
  "#53- A closed mouth gathers no feet.",
  "#54- A cynic is only a frustrated optimist.",
  "#55- A fanatic is one who can't change his mind, and won't change the subject.",
  "#56- You are feeling generous and will leave a substantial tip for the server at the Chinese restaurant.",
  "#57- You seek to find meaning from a little slip of paper inside a little cookie. You are gullible.",
  "#58- The world may be your oyster, but it doesn't mean you'll get its pearl.",
  "#59- Pick another cookie",
  "#60- You are surrounded by fortune hunters",
  "#61- You will receive a fortune cookie.",
  "#62- Flattery will go far tonight.",
  "#63- Water is your friend. It will help you wash down your fortune cookie.",
  "#64- Your fortune cookie will taste suspiciously like an ice cream cone without the ice cream",
  "#65- Opps… wrong cookie",
  "#66- Never give up unless defeat arouses that girl in accounting",
  "#67- Disregard this cookie",
  "#68- Only listen to future cookies",
  "#69- The road to riches is paved with homework",
  "#70- Help!!! I am being held hostage in a Chinese bakery",
  "#71- The fortune you seek is in another cookie",
  "#72- Man who run behind car get exhausted.",
  "#73- Some fortune cookies hold no fortune",
  "#74- Marriage lets you annoy one special person for the rest of your life",
  "#75- Today is probably a huge improvement over yesterday",
  "#76- Never tease a midget with a high five",
  "#77- Don’t play leap frog with a unicorn",
  "#78- He who eats too many prunes, sits on toilet many moons.",
  "#79- If you think we are going to sum up your whole life on this little piece of paper your crazy",
  "#80- You will receive a fortune (cookie)",
  "#81- You will be hungry again in one hour",
  "#82- Don’t eat Chinese food today",
  "#83- That wasn’t chicken",
  "#84- Fortune not found? Abort, Retry, Ignore",
  "#85- It’s about time I got out of that cookie",
  "#86- Always keep your words soft and sweet, just in case you have to eat them.",
  "#87- Don’t fry bacon in the nude.",
  "#88- A good time to keep your mouth shut is when you're in deep water.",
  "#89- From the same people holding the prisoner?",
  "#90- Always borrow money from a pessimist. He won't expect it back",
  "#91- Your colon will self destruct in five seconds.",
  "#92- A recent prison escapee that is sitting nearby wants to love you long time.",
  "#93- Your dog Sparky... well, he's no longer missing",
  "#94- Please don't eat me.",
  "#95- Only a fool would look to a cookie for words of wisdom.",
  "#96- See the waiter about our new food poison life insurance policies.",
  "#97- You will need good reading material in approximately 15 minutes.",
  "#98- Don’t kiss an elephant on the lips today",
  "#99- Never trouble trouble till trouble trouble’s you",
  "#100- If you grow up to be famous you ow me $100 because i totally called it!",
  "#101- WARNING! Do not eat your fortune.",
  "#102- Come back later. I need a nap. Yes, fortune cookies sleep.",
  "#103- No fortune for you.",
  "#104- Better to Press Shirt than Press Luck",
  "#105- Confuscius say 'Man who fart in church sit in own pew'",
  "#106- Confuscius say, Tack in chair fun but screw in bed more fun.",
  "#107- Have you seen the cat?",
  "#108- You are the crunchy noodle in the vegetarian salad of life",
  "#109- Enjoy life! It is better to be happy than wise.",
  "#110- You will become better acquainted with a coworker.",
  "#111- Meet your opponent half way. You need the exercise.",
  "#112- You have a curious smile and a mysterious nature.",
  "#113- Change your thoughts and you change the world.",
  "#114- The man on the top of the mountain did not fall there.",
  "#115- Never miss a chance to keep your mouth shut.",
  "#116- Patience is bitter, but its fruit is sweet.",
  "#117- Minor aches today are likely to pay off handsomely tomorrow.",
  "#118- Don't pursue happiness - create it.",
  "#119- The secret of staying young is good health and lying about your age.",
  "#120- This is really a lovely day. Congratulations!",
  "#121- The Wheel of Good Fortune is finally turning in your direction!",
  "#122- Everybody feels lucky for having you as a friend.",
  "#123- You have an important new business development shaping up.",
  "#124- The love of your life is stepping into your planet this summer.",
  "#125- Enhance your karma by engaging in various charitable activities.",
  "#126- In this life it is not what we take up, but what we give up, that makes us rich.",
  "#127- Reading to the mind is what exercise is to the body.",
  "#128- If you are afraid to shake the dice, you will never throw a six.",
  "#129- You will have a long and wealthy life.",
  "#130- The best way to give credit is to give it away.",
  "#140- Don't lead if you won't lead.",
  "#141- Keep it simple. The more you say, the less people remember.",
  "#142- The race is not always to the swift, but to those who keep on running.",
  "#143- Take control of your life rather than letting things happen just like that!",
  "#144- Did you remember to order your take out also?",
  "#145- Prosperity makes friends and adversity tries them.",
  "#146- A new business venture is on the horizon.",
  "#147- Love or money, or neither?",
  "#148- Your present question marks are going to succeed.",
  "#149- Everything happens for a reason.",
  "#150- You don't need talent to gain experience."
};

int rect_intersect(rectangulo* a, rectangulo* b){
  int res1 = 0;
  int res2 = 0;
  res1 = intersect_interval(a->_x, a->_x+a->_c-1, b->_x, b->_x + b->_c-1);
  res2 = intersect_interval(a->_y, a->_y+a->_a-1, b->_y, b->_y + b->_a-1);
  return res1 && res2;
}

int intersect_interval(short min0, short max0, short min1, short max1){
  double res1=0;
  double res2=0;
  res1 = fmax(min0, max0) > fmin(min1, max1);
  res2 = fmin(min0, max0) < fmax(min1, max1);
  return res1 && res2;
}

int limitex(short x0, short x1){
  short res = 0;
  if(g.print_buffer && g.rotacao ){
    res = !(x0 > 0 && x1 < 26); // return 1 é erro
  } else {
    res = !(x0 > 0 && x1 < 81); // return 1 é erro
  }
   return res;
}

int limitey(short y0, short y1){
  short res = 0;
  if(g.print_buffer && g.rotacao ){
    res = !(y0 > 0 && y1 < 81); // return 1 é erro
  } else {
    res = !(y0 > 0 && y1 < 26); // return 1 é erro
  }
   return res;
}

int rect_descendente(const void* a, const void* b){
  short res=0;
    rectangulo* _a = *(rectangulo**)a;
    rectangulo* _b = *(rectangulo**)b;
    if ( (_a->_y < _b->_y) && (_a->_x > _b->_x) ) res =  -1;
    if ( (_a->_y == _b->_y) && (_a->_x > _b->_x) ) res = -1;
    if ( (_a->_y == _b->_y) && (_a->_x < _b->_x) ) res =  1;
    if ( (_a->_y < _b->_y) && (_a->_x < _b->_x) ) res =  -1;
    if ( (_a->_y > _b->_y) ) res =   1;
    if ( (_a->_y < _b->_y) ) res =  -1;
    return res;
}

void order_rect_desc(){
  qsort (g._u, g._tam_uarray, sizeof(struct rectangulo*), rect_descendente);
}

int colisao(rectangulo* a){
  for (size_t j = 0; j < g._tam_uarray; j++) {
    if( a != g._u[j] ){
      if(rect_intersect(a, g._u[j])  ){
        return 1; // erro
      }
    }
  }
  return 0; // ok
}

int gravidade(){
  for (size_t i = 0; i < g._tam_uarray; i++) {
    while (1) {
      g._u[i]->_y--;
      if( (limitey(g._u[i]->_y, g._u[i]->_y+g._u[i]->_a-1)) || (colisao(g._u[i])) ){
        g._u[i]->_y++;
        break;
      }
    }
  }
  return 0;
}

int rot_rect(rectangulo* a){
  short go = 1;
  unsigned short tmp = a->_x;
  a->_x = a->_y;
  a->_y = 26 - tmp;
  // swap dimensões
  tmp = a->_a;
  a->_a = a->_c;
  a->_c = tmp;

  while (go){
    if(go > 25){
      a->_x++;
    }
    if( limitey(a->_y, a->_y+a->_a+1) && (!colisao(a))  ){
      a->_y--;
    }
    if( colisao(a) && (!limitey(a->_y, a->_y+a->_a+1)) ){
       a->_y++;
    }
    if( (!colisao(a)) && (!limitey(a->_y, a->_y+a->_a+1)) ){
      go = 0;
    } else {
      go++;
    }
  }
  //assert(1 == colisao(a));
  return 0;
}

void sair(){exit(EXIT_SUCCESS);}
int sair_i(){exit(EXIT_SUCCESS);}
void func_stub(){  printf("%s\n", "Func stub");}

void handle_resize(int sig){
signal(SIGWINCH, SIG_IGN);
get_term_size();
signal(SIGWINCH, handle_resize);
}

void get_term_size(){
  struct winsize w; // lin x col
  ioctl(STDOUT_FILENO, TIOCGWINSZ, &w);
  g.lin = w.ws_row;
  g.col = w.ws_col;
  //printxy(20, 39,"lin x col  %d X  %d", w.ws_row, w.ws_col);
}

void set_ini_interface(){
  int tam = TAM_ARRAY(txt_fortune);
  clrscr();
  get_term_size();
  print_in_middle(0, 4, g.col,"UC: 21178 - Laboratorio de Programacao");
  print_in_middle(0, 5, g.col,"EFOLIO B - 18/05/2020");
  print_in_middle(0, 6, g.col,"- Marcio Santos n.º 1502471");
  print_in_middle(0, g.lin/2, g.col, "Fortune Cookie: ");
  print_in_middle(0, g.lin/2+1, g.col, txt_fortune[random_number(tam)] );
  print_in_middle(0, g.lin/2+3, g.col, "Escolha um tipo de interface:");
  print_in_middle(0, g.lin/2+4, g.col, "(D)irecto ao ecran  ou  (B)uffer no ecran\n");
  printxy(20, 20, "%s", " ");
  print_box_header();
  gotoxy(0,23);
}

int create(short x, short y, short l, short h){
rectangulo* item = 0;

if(l < MINLARGURA){
  fprintf(stdout, "Erro: Largura min é 3. Não é possível realizar a operação.\n");
  return 1;
}
if(h < MINALTURA){
  fprintf(stdout, "Erro: Altura min é 3. Não é possível realizar a operação.\n");
  return 1;
}

if (limitex(x,x+l)){
  fprintf(stdout, "Erro: Fora dos limites em x. Não é possível realizar a operação.\n");
  return 1;
}
if (limitey(y, y+h)){
  fprintf(stdout, "Erro: Fora dos limites em y. Não é possível realizar a operação.\n");
  return 1;
}

if ( (item = (rectangulo*)calloc(1, sizeof(struct rectangulo))) ){
  item->_i = g._tam_uarray;
  item->_x = x;
  item->_y = y;
  item->_c = l;
  item->_a= h;
} else {
  return 1; // erro
}
if(g._tam_uarray > 0){
  if (colisao(item)){
    fprintf(stdout, "Colisao. Não é possível realizar a operação.\n");
    free(item);
    return 1; // erro
  }
}
  g._tam_uarray++;
  g._u[g._tam_uarray-1] = item;
  return 0; // ok
}

void print_all(){
  short offset=0;
  clrscr();
  if(g.print_buffer){
    for(int i=0;i < 2025;i++){
      *(g.mundo+i) = " ";
    }
  }
  for (size_t i = 0; i < g._tam_uarray; i++) {
    if (g.print_buffer){
      print_buffer(g._u[i]);
    } else {
      print_rect(g._u[i]);
    }
  }
   if(g.print_buffer){
     if(g.rotacao){
       offset = 25;
       for(int i=0;i < 80;i++){
         for(int j=1;j < 26;j++){
           printf("%s", *(g.mundo+j+(i*offset)) ); // 25
         }
         if (i < 79){
            printf("\n");
         }
       }
     } else {
       offset = 80;
       for(int i=0;i < 25;i++){
         for(int j=1;j < 81;j++){
           printf("%s", *(g.mundo+j+(i*offset)) ); // 79
         }
         if(i < 24){
            printf("\n");
         }
       }
     }
   }
}

int find_pos_rect(short x, short y){
  for(int i=0; i < g._tam_uarray; i++){
    if(g._u[i]->_x == x && g._u[i]->_y == y ){
      return g._u[i]->_i;
    }
  }
  return -1; // não encontrou
}

int info_rect(short id){
  printf("id:[%i]; x:%i; y:%i; c:%i; a:%i;\n", g._u[id]->_i, g._u[id]->_x, (g._u[id]->_y), g._u[id]->_c, g._u[id]->_a);
  return 0;
}

void print_rect(rectangulo* r){
  short x = r->_x;
  short y = 25 - r->_y; // 25-x corrigir o offset vertical
  short c = r->_c;
  short a = r->_a;
  short i = 0;
  printxy(x, y, "%s", "+"); // inf esq
  printx(x+1,y,c-1,'-'); // linha baixo
  for(i=1;i < a-1;i++){
    printxy(x,y-i,"%c", '|'); // linha esquerda
  }
  printxy(x+c-1, y, "%s", "+"); // inf drt
  printx(x+1,y-a+1,c-1,'-'); // linha cima
  for(i=1;i < a-1;i++){
      printxy(x+c-1,y-i,"%c", '|'); // linha direita
  }
  printxy(x, y-a+1, "%s", "+"); // sup esq
  printxy(x+c-1, y-a+1, "%s", "+"); // sup drt
  if (g.debug){
    printxy(x+1, y-1, "%ld", r->_i); // id do rect
  }
  gotoxy(80,24);
}

void print_buffer(rectangulo* r){
  short x = r->_x;
  short y = 0;
  if (g.rotacao){
      y = 80 - r->_y; // 80-x corrigir o offset vertical
  } else {
      y = 25 - r->_y; // 25-x corrigir o offset vertical
  }
  short c = r->_c;
  short a = r->_a;
  short i = 0;
  short offset=0;

  (g.rotacao == 1) ?  (offset = 25) : (offset = 80);

  *(g.mundo+x+(y*offset)) = "+"; // inf esq
  for(i=1;i < c-1;i++){ // linha baixo
    *(g.mundo+x+i+(y*offset)) = "-";
  }
  for(i=1;i < a-1;i++){
    *(g.mundo+x+((y-i)*offset)) = "|"; // linha esquerda
  }
  *(g.mundo+x+c-1+(y*offset)) = "+"; // inf drt
  for(i=1;i < c-1;i++){ // linha cima
    *(g.mundo+x+i+((y-a+1)*offset)) = "-";
  }
  for(i=1;i < a-1;i++){
    *(g.mundo+x+c-1+((y-i)*offset)) = "|"; // linha direita
  }
  *(g.mundo+x+((y-a+1)*offset)) = "+"; // sup esq
  *(g.mundo+x+c-1+((y-a+1)*offset)) = "+"; // sup drt
  if (g.debug){
    snprintf(g.buffer, 3 , "%i", r->_i); // id do rect
    *(g.mundo+x+1+((y-1)*offset)) = strcpy((char*)calloc(3, sizeof(char*)), g.buffer);
  }
}

void print_box_bottom(){
  printx(1,g.lin-2,g.col,'-');
  printx(1,g.lin,g.col,'-');

  printxy(0,g.lin-1,"%c", '|');
  printxy(g.col,g.lin-1,"%c", '|');

  printxy(0,g.lin-2, "%s", "+");
  printxy(g.col, g.lin-2, "%s", "+");
  printxy(0, g.lin, "%s", "+");
  printxy(g.col, g.lin, "%s", "+");

  print_in_middle(2, g.lin-1, g.col-2, "Q|q - Sair; M|m - Menu inicial; A|a - Alunos; U|c - UC's; L|l - Listagens");
}

void print_box_nav(const char* seccao){
  printx(1,4,g.col,'-');
  printx(1,6,g.col,'-');

  printxy(0,5,"%c", '|');
  printxy(g.col,5,"%c", '|');

  printxy(0, 4, "%s", "+");
  printxy(g.col, 4, "%s", "+");
  printxy(0, 6, "%s", "+");
  printxy(g.col, 6, "%s", "+");

  print_in_middle(2, 5, g.col-2, seccao);
}

void print_box_header(){
  printx(1,0,g.col,'-');
  printx(1,3,g.col,'-');

  printxy(0,2,"%c", '|');
  printxy(g.col,2,"%c", '|');

  printxy(0, 0, "%s", "+");
  printxy(g.col, 0, "%s", "+");
  printxy(0, 3, "%s", "+");
  printxy(g.col, 3, "%s", "+");

  print_in_middle(2, 2, g.col-2, "EFOLIO B - Mundo dos rectangulos - UAb");
}

int c_getch(void){
  struct termios o, n; // ler 1 char sem eco
  int ch;
  tcgetattr(0, &o);
  n = o;
  n.c_lflag &= ~ICANON;
  n.c_lflag &= ~ECHO;
  tcsetattr(0, TCSANOW, &n);
  ch = getchar();
  tcsetattr(0, TCSANOW, &o);
  return ch;
}

void printxy(int x, int y, const char *formato, ...){
    va_list args;
    va_start(args, formato);
    printf("\033[%d;%dH", y, x);
    vprintf(formato, args);
    va_end(args);
    fflush(stdout);
}

void printx(int x, int y, int lim, const char ch){
    printf("\033[%d;%dH", y, x);
    for (int i=0; i < lim; i++){
        putchar(ch);
    }
}

void gotox(unsigned int x){
printf("\x1b[%dG", x);
}

void gotoxy(unsigned int x, unsigned int y){
printf("\x1b[%d;%df", y, x);
}

void nocursor(){
printf("\x1b[?25l");
}

void showcursor(){
printf("\x1b[?25h");
}

void clrscr(){
  printf("\e[1;1H\e[2J");
}

void print_in_middle(int startx, int starty, int largura, const char* string){
  int comp=0, x=0, y=0;
	float temp=0;

	x = startx;
	y = starty;
	if(largura == 0) // col
		largura = 80;

	comp = strlen(string);
	temp = (largura - comp)/ 2;
	x = startx + (int)temp;
	printxy(x, y, "%s", string);
}

int random_number(int interval){
 unsigned int randval;
 FILE *f;
 f = fopen("/dev/urandom", "r");
 fread(&randval, sizeof(randval), 1, f);
 fclose(f);
 //printf("%u\n", randval);
 return randval % interval;
}

const char* lower_string(const char* t){
  int c = 0;
  char* s = (char*) t;
  while (s[c] != '\0') {
    if (s[c] >= 'A' && s[c] <= 'Z') {
      s[c] = s[c] + 32;
    }
    c++;
  }
  return (const char*) s;
}

void carregar_ficheiro(){
  FILE* f=NULL;

  if ( (f = fopen("valores.csv","r")) != NULL){
    while (!feof(f)) {
      memset(&g.param,0, STRPARAM);
      fgets(g.param, STRPARAM, f);
      if(strlen(g.param) < 7){
        continue;
      }
      if (get_param(4)){
        fprintf(stdout, "Load: Erro a obter params\n");
        return;
      } else {
        if(create(g._param1, g._param2, g._param3, g._param4 )){
          fprintf(stdout, "Erro na criação do rect. %hu %hu %hu %hu\n", g._param1, g._param2, g._param3, g._param4);
        }
      }
    }
    fclose(f);
  }
}
